-- all strings to/from Bytitura are utf-8, include filenames
-- all constants (BTT_API_VERSION, decode_engine_ia32, ...) from bytitura.h

-- 3 necessarily functions:
-- ApiVersionUsed
-- IKnowThisFile
-- ParseFile

local  BTT_API_VERSION    = 2506

local  decode_engine_none = 0
local  decode_engine_ia32 = 1


function  BttTitle()
  return  "SimpleDosHeader@lua"
end


-- 1st necessarily function
function  ApiVersionUsed()
  return  BTT_API_VERSION 
end


-- 2nd necessarily function
function  IKnowThisFile( filename )

  if Filesize( filename ) < 32 then 
    return -1 
  end

  local  file = io.open( filename )
  local  sign = file:read( 2 )
  file:close()

  if sign ~= "MZ" then
    return -1
  end

 return  0,                  -- base_address
         16,                 -- codesize 16|32|64,  0 as data
         decode_engine_ia32, -- decode_engine_ia32 for code,  decode_engine_none for data
         0                   -- file_flags      

-- return -1 if don't know
end


-- 3rd necessarily function
function  ParseFile( file_index, filename, base_address, codesize )
 
  local  filesize = Filesize( filename )
  BttFileAddDataSegment( file_index, 0, 0, filesize, 0 )

  BttFileMakeStruct( file_index, 0, "DOS_HEADER" )

  return  1
-- return -1 if failed
end


function  Filesize( filename )
  local  file = io.open( filename )
  local  size = file:seek( "end" )
                file:close()
  return size
end
